go-mod-outdated:

    image: docker-registry.wikimedia.org/${WM_APPSEC_GOLANG_IMAGE}
    stage: test
    allow_failure: false #  SHOULD fail pipeline
    rules:
      - when: always
    
    variables:
        GO_MOD_OUTDATED_OPTIONS: ""

    before_script:
        - apt-get update -yqq && apt-get install -yqq ca-certificates curl git golang-go
        - | 
          # check if alternative tool options were specified calling gitlab-ci.yml file
          if [ ! -z "$WM_APPSEC_GO_MOD_OUTDATED_OPTIONS" ]; then
            GO_MOD_OUTDATED_OPTIONS=${WM_APPSEC_GO_MOD_OUTDATED_OPTIONS}
          fi 
          
          # install go mod outdated wrapper:
          export PATH=$PATH:/usr/local/go/bin
          GOBIN=/usr/local/bin/ go install github.com/psampaz/go-mod-outdated@latest

    # run go-mod-outdated against all found go.mod files 
    script:
        - |
          root_dir=$(pwd)
          file_list=$(find "$root_dir" -name "go.mod")

          # find all go.mod files and run audit-ci against them
          TOTAL_EXIT_CODES=0
          for f in $file_list; do
            go_dir="$(dirname "$f")"
            cd $go_dir
            go mod download
            echo -e "\n "
            echo -e "----- $f -----"
            echo -e "\n "
            set -e
            EXIT_CODE=0
            go list -u -m -json all | go-mod-outdated -ci ${GO_MOD_OUTDATED_OPTIONS} || EXIT_CODE=$?
            TOTAL_EXIT_CODES=$(($TOTAL_EXIT_CODES + $EXIT_CODE))
            cd $root_dir
          done
          
          if [ "$TOTAL_EXIT_CODES" -gt 0 ]; then
            echo -e "\n "
            echo -e "At least one go.mod file contained outdated dependencies, please review."
            echo -e "\n "
            exit 1
          fi
